<h2>Generate</h2>

<p>
  This is the JSON configuration used to convert the CashScript Artifacts into a
  BitAuth Template. We need to do this as we need to indicate to WC which values
  should be signed by the Wallet. Conceptually, the idea here is that this
  template can be signed and marked as trusted (click the "Sign Template" button
  for more explanation).
</p>

<h3>keys</h3>
<p>
  These are the Signer Keys that will be available in the template (think of
  these as distinct WC entities/participants).
</p>

<h3>signerKeys</h3>
<p>
  These are the variables (as they are named in the CashScript code) that will
  need to be processed by the Wallet and must be described in CashASM.
</p>
<p>
  Note that CashASM does not directly provide properties for Public Key or
  Address Derivation, so you will need to provide the CashASM to evaluate these.
</p>
<p>
  <strong
    >All locking scripts will have a replica created suffixed in "_sign" for use
    with Wallet Connect that contains these variables/evaluations. When locking,
    you will want to use these "_sign" scripts and when unlocking, you will want
    to use the regular redeem script (as, at that point, you should have the
    evaluated parameters available)</strong
  >
</p>

<h3>appendScripts?</h3>
<p>
  Raw CashASM Scripts that should be appended to the template. Useful if you
  need to use CashASM's schnorr_data_signature as it can only sign a script -
  not a variable.
</p>

<h3>appendVarialbes?</h3>
<p>
  Variables that should be appended to the template. Useful if you need to use
  CashASM's schnorr_data_signature as you will most likely want to pass a
  variable into the signing script.
</p>

<h3>typeHints?</h3>
<p>
  Additional type hints that cannot be inferred from the artifact's variable
  name + type.
</p>

<h2>TODO</h2>
<p>
  NOTE: This format is pretty shitty and there's lots of room for improvement
  (or revision entirely). But it demonstrates the concept.
</p>
